Bug 448104 - corrupt glyph positions with large font
corrupt glyph positions with large font
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: cairo (Show other bugs)
rawhide
All Linux
low Severity low
: ---
: ---
Assigned To: Behdad Esfahbod
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-05-23 10:11 EDT by Caolan McNamara
Modified: 2008-08-23 23:47 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-08-23 23:47:10 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)
screen shot (25.39 KB, image/png)
2008-05-23 10:11 EDT, Caolan McNamara
no flags Details
test case (6.09 KB, text/plain)
2008-05-23 10:12 EDT, Caolan McNamara
no flags Details

  None (edit)
Description Caolan McNamara 2008-05-23 10:11:48 EDT
Attached is a test-case boiled out of OpenOffice.org and bolted onto the xlib
cairo-demo. It attempt to render the string MoWoW and the string MWooW with a
very large Liberation Serif font. And the screenshot shows the results. Unless
I'm being very slow today (always possible) there is something terribly screwed
up going on. 

cairo-1.6.4-1.fc9.i386
I see this both with a i810 driver and a nv driver.
Comment 1 Caolan McNamara 2008-05-23 10:11:48 EDT
Created attachment 306499 [details]
screen shot
Comment 2 Caolan McNamara 2008-05-23 10:12:59 EDT
Created attachment 306500 [details]
test case
Comment 3 Carl Worth 2008-05-23 10:54:06 EDT
I've replicated this bug with the r100 driver as well. So it appears to be
a fairly generic cairo-xlib or X server bug. Note that the bug does not appear
when rendering to a cairo image surface. Also, the bug is present with at least
both of "Liberation Sans" and "Bitstream Vera Sans".

-Carl
Comment 4 Carl Worth 2008-05-23 11:06:33 EDT
I've also added a new large-font test to cairo's test suite to exercise this bug.

It also verifies that all backends other than cairo-xlib pass the test.

-Carl
Comment 5 Behdad Esfahbod 2008-05-23 13:58:43 EDT
Isn't this the bug reported here:
http://lists.cairographics.org/archives/cairo/2008-May/014033.html
Comment 6 Carl Worth 2008-05-23 15:17:53 EDT
(In reply to comment #5)
> Isn't this the bug reported here:
> http://lists.cairographics.org/archives/cairo/2008-May/014033.html

Could be. I hadn't done any analysis of that one, so hadn't remembered it.

No fix yet?

Behdad, does Vlad's suggestion sound right?

I'm still looking close to try to understand this one myself. Where is
the glyph data getting shuffled for example?

-Carl
Comment 7 Behdad Esfahbod 2008-05-23 16:25:57 EDT
Vlad's fix doesn't work:
http://lists.cairographics.org/archives/cairo/2008-May/014044.html

I'll fix this today, perhaps using what I suggest in the above URL.
Comment 8 Behdad Esfahbod 2008-05-23 20:19:53 EDT
I've pushed a couple fixes to cairo master now.  Please test.
Comment 9 Caolan McNamara 2008-05-24 09:02:05 EDT
Yes latest git version works just right for me
Comment 10 Matthias Clasen 2008-08-23 23:47:10 EDT
That probably means we can close this bug now, with cairo 1.7.4 in rawhide.

Note You need to log in before you can comment on or make changes to this bug.